var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _JSONParseStream_instances, _JSONParseStream_pathMap, _JSONParseStream_jsonPath, _JSONParseStream_filterStream, _JSONParseStream_a, _JSONParseStream_readable_get, _JSONParseStream_clone;
// deno-lint-ignore-file no-explicit-any no-cond-assign ban-unused-ignore no-unused-vars
import { streamToAsyncIter } from 'whatwg-stream-to-async-iter';
import { JSONParser } from './json-parser.js';
import { normalize, match } from './json-path.js';
async function* _identity(iter) {
    for await (const x of iter)
        yield x;
}
// FIXME: avoid string concatenation/joining
const mkPath = (parser) => {
    const path = [...parser.stack.map((_) => _.key), parser.key]; // TODO: modify parser to provide key efficiently
    path[0] = path[0] || '$';
    return normalize(path.join('.')); // FIXME: avoid string concatenation/joining
};
/**
 *
 */
export class JSONParseStream extends TransformStream {
    constructor(jsonPath = '$.*') {
        let parser;
        super({
            start: (controller) => {
                parser = new JSONParser();
                parser.onValue = (value) => {
                    const path = mkPath(parser);
                    // FIXME: better solution?
                    __classPrivateFieldGet(this, _JSONParseStream_pathMap, "f").set(value, path);
                    controller.enqueue(value);
                };
            },
            transform: (chunk) => {
                parser.write(chunk);
            },
        });
        _JSONParseStream_instances.add(this);
        _JSONParseStream_pathMap.set(this, new Map()); // FIXME: clear!
        // #streams = new Map<string, ReadableStream<unknown>>();
        _JSONParseStream_jsonPath.set(this, void 0);
        _JSONParseStream_a.set(this, void 0);
        const expr = normalize(jsonPath);
        __classPrivateFieldSet(this, _JSONParseStream_jsonPath, expr, "f");
    }
    // FIXME: Just acquiring this property will lock the internal stream. Different from regular transform stream.
    get readable() {
        return __classPrivateFieldGet(this, _JSONParseStream_instances, "a", _JSONParseStream_readable_get).pipeThrough(__classPrivateFieldGet(this, _JSONParseStream_instances, "m", _JSONParseStream_filterStream).call(this, __classPrivateFieldGet(this, _JSONParseStream_jsonPath, "f")));
    }
    async promise(jsonPath) {
        const expr = normalize(jsonPath);
        const stream = __classPrivateFieldGet(this, _JSONParseStream_instances, "m", _JSONParseStream_clone).call(this).pipeThrough(__classPrivateFieldGet(this, _JSONParseStream_instances, "m", _JSONParseStream_filterStream).call(this, expr));
        // this.#streams.set(expr, stream)
        const { done, value } = await stream.getReader().read();
        return done ? undefined : value;
    }
    stream(jsonPath) {
        const expr = normalize(jsonPath);
        const stream = __classPrivateFieldGet(this, _JSONParseStream_instances, "m", _JSONParseStream_clone).call(this).pipeThrough(__classPrivateFieldGet(this, _JSONParseStream_instances, "m", _JSONParseStream_filterStream).call(this, expr));
        // this.#streams.set(expr, stream)
        return stream;
    }
    iterable(jsonPath) {
        return streamToAsyncIter(this.stream(jsonPath));
    }
}
_JSONParseStream_pathMap = new WeakMap(), _JSONParseStream_jsonPath = new WeakMap(), _JSONParseStream_a = new WeakMap(), _JSONParseStream_instances = new WeakSet(), _JSONParseStream_filterStream = function _JSONParseStream_filterStream(expr) {
    return new TransformStream({
        transform: (value, controller) => {
            const path = __classPrivateFieldGet(this, _JSONParseStream_pathMap, "f").get(value);
            if (match(expr, path)) {
                controller.enqueue(value);
            }
            // Closing the stream early when the selected path can no longer yield values
            else if (expr.startsWith(path)) {
                controller.terminate();
                // this.#streams.delete(expr) // no longer need to track the stream
            }
        }
    });
}, _JSONParseStream_readable_get = function _JSONParseStream_readable_get() {
    var _a;
    return (_a = __classPrivateFieldGet(this, _JSONParseStream_a, "f")) !== null && _a !== void 0 ? _a : super.readable;
}, _JSONParseStream_clone = function _JSONParseStream_clone() {
    const [a, b] = __classPrivateFieldGet(this, _JSONParseStream_instances, "a", _JSONParseStream_readable_get).tee();
    __classPrivateFieldSet(this, _JSONParseStream_a, a, "f");
    return b;
};
//# sourceMappingURL=json-parse-stream.js.map