// deno-lint-ignore-file no-explicit-any
import { ResolvablePromise } from '@worker-tools/resolvable-promise';
import { ExtendablePromise } from './deps/raw.githubusercontent.com/worker-tools/extendable-promise/master/index.js';
import { jsonStringifyGenerator } from './json-stringify.js';
export class JSONStringifyStream extends TransformStream {
    constructor() {
        let first;
        let flushed;
        let done;
        super({
            start(controller) {
                first = true;
                flushed = new ResolvablePromise();
                done = new ExtendablePromise(flushed);
                controller.enqueue('[');
            },
            transform(obj, controller) {
                if (!first)
                    controller.enqueue(',');
                else
                    first = false;
                const p = (async () => {
                    for await (const chunk of jsonStringifyGenerator(obj)) {
                        controller.enqueue(chunk);
                    }
                })();
                done.waitUntil(p);
                return p;
            },
            async flush(controller) {
                flushed.resolve();
                await done; // FIXME: is this even necessary?
                controller.enqueue(']');
            }
        });
    }
}
//# sourceMappingURL=json-stringify-stream.js.map