// deno-lint-ignore-file no-explicit-any
import { streamToAsyncIter } from 'whatwg-stream-to-async-iter';
import { BinarySplitStream } from './split-stream.js';
/** @deprecated Untested */
export class NDJSONParseStream extends TransformStream {
    constructor() {
        let splitStream;
        let writer;
        let decoder;
        super({
            start(controller) {
                splitStream = new BinarySplitStream();
                writer = splitStream.writable.getWriter();
                decoder = new TextDecoder();
                (async () => {
                    try {
                        for await (const line of streamToAsyncIter(splitStream.readable)) {
                            const sLine = decoder.decode(line).trim();
                            if (sLine)
                                controller.enqueue(JSON.parse(sLine));
                        }
                    }
                    catch (err) {
                        writer.abort(err);
                    }
                })();
            },
            transform(chunk) {
                writer.write(chunk);
            },
            flush() {
                writer.close();
            },
        });
    }
}
//# sourceMappingURL=ndjson-parse-stream.js.map