"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NDJSONParseStream = void 0;
// deno-lint-ignore-file no-explicit-any
const whatwg_stream_to_async_iter_1 = require("whatwg-stream-to-async-iter");
const split_stream_js_1 = require("./split-stream.js");
/** @deprecated Untested */
class NDJSONParseStream extends TransformStream {
    constructor() {
        let splitStream;
        let writer;
        let decoder;
        super({
            start(controller) {
                splitStream = new split_stream_js_1.BinarySplitStream();
                writer = splitStream.writable.getWriter();
                decoder = new TextDecoder();
                (async () => {
                    try {
                        for await (const line of (0, whatwg_stream_to_async_iter_1.streamToAsyncIter)(splitStream.readable)) {
                            const sLine = decoder.decode(line).trim();
                            if (sLine)
                                controller.enqueue(JSON.parse(sLine));
                        }
                    }
                    catch (err) {
                        writer.abort(err);
                    }
                })();
            },
            transform(chunk) {
                writer.write(chunk);
            },
            flush() {
                writer.close();
            },
        });
    }
}
exports.NDJSONParseStream = NDJSONParseStream;
//# sourceMappingURL=ndjson-parse-stream.js.map